MODULE grf1dexec

  PRIVATE
  PUBLIC grf1d_exec

CONTAINS

! ***** DRAW 1D GRAPH *****

  SUBROUTINE GRF1D_EXEC(GX,GF,NXM,NXMAX,NYMAX,A)

    USE grftype, ONLY: grf_attr_type
    USE grfutils, ONLY: grf_title, grf_frame1d, setrgba
    IMPLICIT NONE

    REAL(4),INTENT(IN):: GX(NXMAX),GF(NXM,NYMAX)
    INTEGER,INTENT(IN):: NXM,NXMAX,NYMAX
    TYPE(grf_attr_type),INTENT(IN):: A
    INTEGER:: NY,NL

    CALL GDEFIN(A%GPXMIN,A%GPXMAX,A%GPYMIN,A%GPYMAX, &
                A%XMIN,A%XMAX,A%FMIN,A%FMAX)
    DO NY=1,NYMAX
       NL=MOD(NY-1,A%NLMAX)+1
       CALL SETLNW(A%LINE_THICKNESS(NL))
       CALL SETMKS(0,A%LINE_MARK_SIZE(NL))
       CALL SETRGBA(A%LINE_RGB(1:3,NL))
       CALL GPLOTP(GX,GF(1:NXMAX,NY),A%NXMIN,NXMAX,A%NXSTEP, &
                   A%LINE_MARK(NL),A%LINE_MARK_STEP(NL),A%LINE_PAT(NL))
    ENDDO
    CALL SETRGB(0.0,0.0,0.0)

    IF(A%NOFRAME.EQ.0) CALL GRF_FRAME1D(A)
    IF(A%NOTITLE.EQ.0) CALL GRF_TITLE(A)
    CALL SETRGB(0.0,0.0,0.0)

    RETURN
  END SUBROUTINE GRF1D_EXEC
END MODULE grf1dexec
